package httpload;

import java.util.*;

import org.apache.commons.httpclient.*;

/**
 *	ẢʑViI\NX
 */
public class HttpLoadScenario extends Observable implements Runnable, Cloneable
{
	/** ViIʎq */
	private String name;

	/** ViI̊eXebv */
	private Vector step;

	/** dx */
	private int numThread;

	/** Recۑ邩ǂ̃tO */
	private boolean isContentsSave;

	/**
	 *	ftHgRXgN^
	 */
	public HttpLoadScenario()
	{
		this.step = new Vector();
	}

	/**
	 *	ViI̎s
	 */
	public void run()
	{
		// ύXJn
		setChanged();

		HttpClient client = new HttpClient();

		for(int i=0; i<step.size(); i++)
		{
			HttpLoadStep anStep = (HttpLoadStep)step.get(i);
			anStep.execute(client);
		}

		// ̏IObserverɒʒm
		notifyObservers();

		// ύX̏I
		clearChanged();
	}

	/**
	 *	Xebv̎擾
	 */
	public HttpLoadStep[] getStep()
	{
		// Vector  zϊ
		HttpLoadStep[] steps = new HttpLoadStep[step.size()];
		step.toArray(steps);

		return steps;
	}

	/**
	 *	XebṽZbg
	 */
	public void setStep(Vector step)
	{
		this.step = step;
	}

	/**
	 *	Xebv̒ǉ
	 */
	public void addStep(HttpLoadStep step)
	{
		this.step.add(step);
	}

	/**
	 *	Object#toString̃I[oCh
	 */
	public String toString()
	{
		StringBuffer buffer = new StringBuffer();
		String lineSep = System.getProperty("line.separator");

		buffer.append("numThread = " + getNumThread() + lineSep);
		HttpLoadStep[] steps = getStep();
		for(int i=0; i<steps.length; i++)
		{
			buffer.append("numRepeat = " + steps[i].getNumRepeat() + lineSep);
			buffer.append("method = " + steps[i].getHttpLoadRequest().getMethod() + lineSep);
			buffer.append("URL = " + steps[i].getHttpLoadRequest().getUrl() + lineSep);
			buffer.append("param = " + steps[i].getHttpLoadRequest().getParam() + lineSep);
			buffer.append("Validate = " + steps[i].getHttpLoadValidate() + lineSep);
		}

		return buffer.toString();
	}

	/**
	 *	Object#clonẽI[oCh
	 */
	public Object clone()
	{
		HttpLoadScenario copyObject = new HttpLoadScenario();
		copyObject.setStep((Vector)step.clone());
		copyObject.setNumThread(numThread);

		return copyObject;
	}

	/**
	 *	ʎq̎擾
	 */
	public String getName()
	{
		return name;
	}

	/**
	 *	ʎq̃Zbg
	 */
	public void setName(String name)
	{
		this.name = name;
	}

	/**
	 *	dx̎擾
	 */
	public int getNumThread()
	{
		return numThread;
	}

	/**
	 *	dx̃Zbg
	 */
	public void setNumThread(int numThread)
	{
		this.numThread = numThread;
	}

	/**
	 *	RecۑtO̎擾
	 */
	public boolean isContentsSave()
	{
		return isContentsSave;
	}

	/**
	 *	RecۑtÕZbg
	 */
	public void setIsContentsSave(boolean isContentsSave)
	{
		this.isContentsSave = isContentsSave;
	}
}
