package httpload.output;

import java.util.Observable;

import httpload.*;

/**
 *	ʂR\[ɏo͂NX
 */
public class ConsoleOutput implements HttpLoadOutput
{
	/**
	 *	Observer#updatẽI[oCh
	 */
	public void update(Observable obj, Object arg)
	{
		HttpLoadScenario scenario = (HttpLoadScenario)obj;
		output(scenario);
	}

	/**
	 *	ʏo͏
	 */
	public void output(HttpLoadScenario scenario)
	{
		HttpLoadStep[] steps = scenario.getStep();
		for(int i=0; i<steps.length; i++)
		{
			System.out.println("****************************************");
			HttpLoadRequest anRequest = steps[i].getHttpLoadRequest();
			HttpLoadResponse[] anResponse = steps[i].getHttpLoadResponse();
			System.out.println("URL: " + anRequest.getUrl());
			System.out.println("Param: " + anRequest.getParam());

			for(int j=0; j<anResponse.length; j++)
			{
				if(anResponse.length > 1)
				{
					System.out.println("---------- Repeat ----------");
				}
				System.out.println("StatusCode: " + anResponse[j].getStatusCode());
				System.out.println("ResponseTime: " + anResponse[j].getResponseTime());
				System.out.println("Validation: " + anResponse[j].isValidateOk());
			}
		}
	}
}
