package httpload.util;

import org.apache.regexp.*;

import java.text.*;
import java.util.*;

/**
 *	[eBeB - 񏈗Ɋւ郆[eBeBNX
 */
public class StringUtil
{
	/**
	 *	str𔼊pXy[X́ASpXy[Xŋ؂ĕԂ
	 *
	 *	@param	str	
	 *
	 *	@return	pXy[X́ASpXy[Xŋ؂
	 */
	public static String[] splitSpace(String str)
	{
		Vector result_array = new Vector();

		// pXy[XSpXy[X؂蕶ƂĎw
		StringTokenizer st = new StringTokenizer(str, " @");
		while(st.hasMoreTokens())
		{
			result_array.add(st.nextToken());
		}

		String[] result = new String[result_array.size()];
		result_array.toArray(result);

		return result;
	}

	/**
	 *	strNULL̎͋󕶎AȊȌꍇ͂̂܂ܕԂ
	 *
	 *	@param	str	
	 *
	 *	@return	strNULL̎F󕶎
	 *			ȊȌꍇF̂܂ܕԂ
	 */
	public static String nullEmpty(String str)
	{
		if(str == null)
		{
			return "";
		}
		else
		{
			return str;
		}
	}

	/**
	 *	lJ}ttH[}bg
	 *
	 *	@param	num	l
	 */
	public static String formatNumber(double num)
	{
		DecimalFormat numFormatter = new DecimalFormat("#,###");
		return numFormatter.format(num);
	}

	/**
	 *	X֔ԍ-
	 *
	 *	@param	zip	X֔ԍ
	 *
	 *	@return	X֔ԍ-ꂽ
	 */
	public static String convZip(String zip)
	{
		if(zip == null || zip.length() == 0)
		{
			return "";
		}

		if(zip.length() <= 3 || zip.indexOf("-") != -1)
		{
			return zip;
		}
		else
		{
			return zip.substring(0, 3) + "-" + zip.substring(3);
		}
	}

	/**
	 *	Ώە񂪃p^[ɊY邩ǂ`FbN
	 *
	 *	@param	targetString	Ώە
	 *	@param	pattern			p^[
	 *
	 *	@return	p^[Ƀ}b`trueAłȂfalseԋp
	 */
	public static boolean match(String targetString, String pattern)
	{
		try
		{
			RE regexp = new RE(pattern);
			return regexp.match(targetString);
		}
		catch(Exception ex)
		{
			return false;
		}
	}

	/**
	 *	Ώە̃p^[ɊY镔uŒuB
	 *
	 *	@param	targetString	Ώە
	 *	@param	fromPattern		uΏۃp^[
	 *	@param	toString		u
	 *
	 *	@return	uʂ̕
	 */
	public static String replaceALL(String targetString, String fromPattern, String toString)
	{
		try
		{
			String result = "";

			RE regexp = new RE(fromPattern, RE.REPLACE_ALL);
			result = regexp.subst(targetString, toString);

			return result;
		}
		catch(Exception ex)
		{
			return "";
		}
	}

	/**
	 * SJISGR[hŁA擾
	 *
	 *	@param	strDbData	
	 *
	 *	@return	SJISGR[h
	 */
	public static String getSjisString(String strDbData)
	{
		if(strDbData != null)
		{
			StringBuffer sbDest = new StringBuffer();
			char cDest = 0x0000;
			
			// 
			for(int iI = 0; iI < strDbData.length(); iI++)
			{
				cDest = strDbData.charAt(iI);
				switch (cDest)
				{
					case 0x301c: // `  WAVE DASH -> FULLWIDTH TILDE
					cDest = 0xff5e;
						break;
				}
				sbDest.append(cDest);
			}
	 		return sbDest.toString();
		}else
		{
			return strDbData;
		}
	}
	


}
